/*
 * File   : platten.h
 * Purpose: This file contains all global definations used by more than
 *          one program file.
 * Autor  : Andreas Theofilu
 *
 * Copyright (C) 1998, 1999 by Theos Soft.
 */

/* 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*
 * Common function prototypes
 */
void init ();
void CloseDatabase ();
int CheckSqlError ();
void DisplaySqlError (Widget w);
char *GetCompoundString (XmString cstr, char *ret, int retlen);
char *IDateToChar (long idate, char *sdate);
long CharToIDate (Widget w, char *date);
char *ltrim (char *buf);
char *rtrim (char *buf);
int ReadLine (int fd, char *buf, int len);
Bool GetOptions (Widget w);

void NewSingle ();
void SearchSingle ();
void AddNewSingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void ClearValuesCallback (Widget w, XtPointer client_data, XtPointer call_data);
void QuerySingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void NewSingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void NextSingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void PreviousSingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void OkaySingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void UpdateSingleCallback (Widget w, XtPointer client_data, XtPointer call_data);
void SingleValueChangedCallback (Widget w, XtPointer client_data, XtPointer call_data);
void CheckDateCallback (Widget w, XtPointer client_data, XtPointer call_data);
int CheckDate (Widget w, char *date);

void NewLP ();
void NewLPCut ();
void NewLPCutDialog ();
void UpdateLpCallback (Widget w, XtPointer tag, XtPointer data);
void AddLpLabelCallback (Widget w, XtPointer tag, XtPointer data);
void AddLpCutsCallback (Widget w, XtPointer tag, XtPointer data);
void SearchLps ();
void FirstFillCallback (Widget dialog, Widget list);
void LPSearchValueChangedCallback (Widget w, XtPointer client_data, XtPointer call_data);
void MasterListCallback (Widget w, XtPointer tag, XtPointer data);
void rclClearValuesCallback (Widget w, XtPointer tag, XtPointer data);
void rccClearValuesCallback (Widget w, XtPointer tag, XtPointer data);
void rclInitChooser (Widget wk, Widget wd);
void rclAutoCallback ();
void lpsPartChooserCallback (Widget w, XtPointer tag, XtPointer data);
void lpsSearchTypeCallback (Widget w, XtPointer tag, XtPointer data);
void lpsEnterCellCallback (Widget w, XtPointer tag, XtPointer data);
void lpsCutMasterCallback (Widget w, XtPointer tag, XtPointer data);
void NewKennChangedCallback (Widget w, XtPointer tag, XtPointer data);
void UpdateKennChangedCallback (Widget w, XtPointer tag, XtPointer data);
void UpdrclInitDiscid (Widget w);
void GetCDDBCallback (Widget w, XtPointer tag, XtPointer data);
void PutCDDBCallback (Widget w, XtPointer tag, XtPointer data);

void PrintSingles ();
void PrintLps ();
void StopPrintCallback (Widget w, XtPointer client_data, XtPointer call_data);

void Options ();
void OptionChooserChangedCallback (Widget w, XtPointer tag, XtPointer data);
void OptionDialogInit (Widget w);

/*
 * Global variables
 */
extern Widget toplevel;
extern int has_trans;

/*
 * Global structures for resources.
 */
typedef struct {
	String Database;
	String Version;
	String datePattern;
	String CDDBPath;
	String cdrom;
	String cdmount;
} application_resource_t;

typedef struct
{
	int chPrinter;
	char ipPrinter[51];
	char ipFile[51];
	char ipTrenn[2];
	char ipDatef[11];
} option_t;

extern application_resource_t app_resources;
extern option_t option;
